/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.dolphinscheduler.server.master.engine.command.handler;

import org.apache.dolphinscheduler.common.enums.CommandType;
import org.apache.dolphinscheduler.scheduler.api.SchedulerApi;

import org.springframework.stereotype.Component;

/**
 * Used to handle the {@link CommandType#SCHEDULER} which will start the workflow definition by {@link SchedulerApi}.
 */
@Component
public class ScheduleWorkflowCommandHandler extends RunWorkflowCommandHandler {

    @Override
    public CommandType commandType() {
        return CommandType.SCHEDULER;
    }
}
